# Generated by Django 4.0.6 on 2022-10-15 04:35

import ckeditor.fields
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('jeral', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='ImagenInformasaun',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('imagen', models.ImageField(default='pajina/default.png', upload_to='pajina/')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Informasaun',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('imagen_main', models.ImageField(blank=True, default='pajina/default.png', null=True, upload_to='pajina/')),
                ('status', models.BooleanField(default=False, verbose_name='Staus Publika')),
                ('data', models.DateField(verbose_name='Data')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='KategoriaProdutu',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('titulu', models.CharField(max_length=250)),
                ('imagen', models.ImageField(blank=True, default='produtu/default.png', null=True, upload_to='pajina/')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('lingua', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='jeral.lingua', verbose_name='Hili Lingua')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='Produtu',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('imagen_main', models.ImageField(blank=True, default='produtu/default.png', null=True, upload_to='produtu/')),
                ('presu', models.FloatField(max_length=250)),
                ('status', models.BooleanField(default=False, verbose_name='Staus Publika')),
                ('data', models.DateField(verbose_name='Data')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('foun', models.BooleanField(default=False, verbose_name='Foun')),
                ('kategoriaprodutu', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='kategoria', to='informasaun.kategoriaprodutu')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='Parceiru',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('naran', models.CharField(max_length=150)),
                ('logo', models.ImageField(default='pajina/default.png', upload_to='pajina/')),
                ('file_pdf', models.FileField(blank=True, default='pdf_mamuk.pdf', null=True, upload_to='upload_file_parceiru/')),
                ('data', models.DateField(blank=True, null=True, verbose_name='Data')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='Pajina',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('naran', models.CharField(max_length=150)),
                ('data', models.DateField(blank=True, null=True, verbose_name='Data')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='KonteuduProdutu',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('titulu', models.CharField(max_length=250)),
                ('konteudu', ckeditor.fields.RichTextField()),
                ('data_produsaun', models.DateField(verbose_name='Data')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('lingua', models.ForeignKey(default=1, on_delete=django.db.models.deletion.CASCADE, related_name='linguaprodutu', to='jeral.lingua')),
                ('produtu', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='informasaun.produtu', verbose_name='Hili produtu')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='KonteuduPajina',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('titulu', models.CharField(max_length=150)),
                ('data', models.DateField(blank=True, null=True, verbose_name='Data')),
                ('konteudu', ckeditor.fields.RichTextField()),
                ('imagen', models.ImageField(blank=True, default='pajina/default.png', null=True, upload_to='pajina/')),
                ('file_pdf', models.FileField(blank=True, default='pdf_mamuk.pdf', null=True, upload_to='upload_file_konteudu/')),
                ('linkvideo', models.CharField(blank=True, max_length=150, null=True, verbose_name='Link Video')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('lingua', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='jeral.lingua')),
                ('pajina', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='pajina', to='informasaun.pajina')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='KonteuduInformasaun',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('titulu', models.CharField(max_length=250)),
                ('konteudu', ckeditor.fields.RichTextField()),
                ('status', models.BooleanField(default=False, verbose_name='Staus Publika')),
                ('data', models.DateField(verbose_name='Data')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('informasaun', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='informasaun.informasaun', verbose_name='Hili informasaun')),
                ('lingua', models.ForeignKey(default=1, on_delete=django.db.models.deletion.CASCADE, related_name='lingua', to='jeral.lingua')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='KonteuduImagenInformasaun',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('deskrisaun', ckeditor.fields.RichTextField(max_length=70)),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('imageinformasaun', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='imageninformasaun', to='informasaun.imageninformasaun')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.CreateModel(
            name='ImagenProdutu',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('imagen', models.ImageField(default='produtu/default.png', upload_to='produtu/')),
                ('date_created', models.DateField(blank=True, null=True, verbose_name='Data Rejistu')),
                ('hashed', models.TextField(blank=True, null=True)),
                ('produtu', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='Produtu', to='informasaun.produtu')),
                ('user_created', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User')),
            ],
        ),
        migrations.AddField(
            model_name='imageninformasaun',
            name='informasaun',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='pajina', to='informasaun.informasaun'),
        ),
        migrations.AddField(
            model_name='imageninformasaun',
            name='user_created',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='Hili User'),
        ),
    ]
